package com.ynzc.controller;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import com.ynzc.model.User;
import com.ynzc.util.Page;	
@Controller
@RequestMapping("/User.do")
public class UserController extends BaseController{
	@RequestMapping(params = "action=getPageList", method = RequestMethod.GET)
	public void getPageList(HttpServletRequest request,HttpServletResponse response) throws IOException{
		request.setCharacterEncoding("utf-8");
		response.setContentType("application/json;charset=utf-8");
		PrintWriter out = response.getWriter();	
		JSONObject jsonBack = new JSONObject();
		int currentPage=Integer.parseInt(request.getParameter("currentPage"));
		try{
		Map<String,Object> map1 = new HashMap<String,Object>();
		int totalRecord=Service.getUserService().findAllByFilterCount(map1);
		int totalPage = totalRecord % Page.Length != 0 ? (totalRecord/ Page.Length + 1) : totalRecord / Page.Length;
		if (currentPage < 1 || currentPage > totalPage)
		{
			jsonBack.put("success", false);
			out.print(jsonBack);
			return;
		}
		Page page = new Page();
		page.setCurrentPage(currentPage);
		page.setTotalPage(totalPage);
		page.setTotalRecord(totalRecord);

		Map<String,Object> map2 = new HashMap<String,Object>();
		int start=(currentPage-1)*Page.Length;
		map2.put("start", start);
		map2.put("limit", Page.Length);
		List<User> list=Service.getUserService().findAllByFilter(map2);
		JSONArray jsonItems = new JSONArray();
		for (User model : list) {
			jsonItems.add(JSONObject.fromObject(model));
		}
		jsonBack.put("success", true);
		jsonBack.put("results", jsonItems);
		jsonBack.put("page", JSONObject.fromObject(page));
		out.print(jsonBack);
		}catch(Exception e){
			jsonBack.put("success", false);
			out.print(jsonBack);
			return;
		}
	}


	@RequestMapping(params = "action=GetById", method = RequestMethod.GET)
	public void GetById(HttpServletRequest request,HttpServletResponse response) throws IOException {
		response.setContentType("application/json;charset=utf-8");
		PrintWriter out = response.getWriter();
		JSONObject jsonBack = new JSONObject();
		int id = Integer.parseInt(request.getParameter("id"));
		try {
		User user = Service.getUserService().findById(id);
		if(user==null)
		{
			jsonBack.put("success", false);
			out.print(jsonBack);
		}else
		{
			jsonBack.put("success", true);
			jsonBack.put("result", JSONObject.fromObject(user));
			out.print(jsonBack);
		}
		} catch (Exception e) {
			jsonBack.put("success", false);
			out.print(jsonBack);
		}
	}


	@RequestMapping(params = "action=Add", method = RequestMethod.GET)
	public void Add(HttpServletRequest request,HttpServletResponse response) throws IOException {
		response.setContentType("application/json;charset=utf-8");
		PrintWriter out = response.getWriter();
		JSONObject jsonBack = new JSONObject();
		String name = request.getParameter("name");
		String password = request.getParameter("password");
		String state = request.getParameter("state");
		try {
			User user= new User();
			user.setName(name);
			user.setPassword(password);
			user.setState(1);
			int result=Service.getUserService().insert(user);
			jsonBack.put("success", true);
		out.print(jsonBack);
		} catch (Exception e) {
			jsonBack.put("success", false);
			out.print(jsonBack);
		}
	}


	@RequestMapping(params = "action=edit", method = RequestMethod.GET)
	public void edit(HttpServletRequest request,HttpServletResponse response) throws IOException {
		response.setContentType("application/json;charset=utf-8");
		PrintWriter out = response.getWriter();
		JSONObject jsonBack = new JSONObject();
		int id = Integer.parseInt(request.getParameter("id"));
		String name = request.getParameter("name");
		String password = request.getParameter("password");
		try {
			User user= new User();
			user.setId(id);
			user.setName(name);
			user.setPassword(password);
			int result=Service.getUserService().update(user);
			jsonBack.put("success", true);
			out.print(jsonBack);
		} catch (Exception e) {
			jsonBack.put("success", false);
			out.print(jsonBack);
		}
	}


	@RequestMapping(params = "action=delete", method = RequestMethod.GET)
	public void delete(HttpServletRequest request,HttpServletResponse response) throws IOException {
		response.setContentType("application/json;charset=utf-8");
		PrintWriter out = response.getWriter();
		JSONObject jsonBack = new JSONObject();
		String ids = request.getParameter("ids");
		String[] idArr=ids.split(",");
		List<String> list=new ArrayList<String>();
		for(String s:idArr)
		{
			list.add(s);
		}
		try {
			Map<String,Object> map = new HashMap<String,Object>();
			map.put("ids", list);
			int result=Service.getUserService().delete(map);
			jsonBack.put("success", true);
			jsonBack.put("result", result);
			out.print(jsonBack);
		} catch (Exception e) {
			jsonBack.put("success", false);
			out.print(jsonBack);
		}
	}
}
